unit unMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Spin,
  StdCtrls, ExtCtrls;

type

  { TfrmScanner }

  TfrmScanner = class(TForm)
    btnRefresh: TButton;
    btnDigitise: TButton;
    btnSave: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    memData: TMemo;
    SaveDialog1: TSaveDialog;
    spW: TSpinEdit;
    spH: TSpinEdit;
    procedure btnDigitiseClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure claim(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
  private

  public

  end;

var
  frmScanner: TfrmScanner;

implementation

{$R *.lfm}

{ TfrmScanner }
const size = 30;
  var thing: array[1..30,1..30] of TShape;

procedure TfrmScanner.claim(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);

var me : TShape;
begin
      me := sender as TShape;
      if ssShift in Shift
         then me.Brush.Color := clBlack
         else if ssCtrl in Shift
                 then me.Brush.Color := clwhite
end;

procedure TfrmScanner.btnRefreshClick(Sender: TObject);
var i,j : integer;
    temp : Tshape;

begin
  //clean up last scan
  for i := componentcount-1 downto 0 do
     if components[i] is TShape
        then (components[i] as tshape).Destroy;
  memData.Lines.Clear;

  //draw new scanner field
  for i := 1 to spH.Value do
     for j := 1 to spW.Value do
        begin
            temp := TShape.create(self);
            temp.Parent := frmScanner;
            temp.Top := i*size;
            temp.Left := j*size;
            temp.Width := size;
            temp.Height := size;
            temp.OnMouseMove := @claim;
            thing[i,j] := Temp

        end;



end;

procedure TfrmScanner.btnSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute
      then begin
               memData.Lines.SaveToFile(SaveDialog1.FileName);
           end;
end;

procedure TfrmScanner.btnDigitiseClick(Sender: TObject);

var i, j : integer;
      temp : string;
begin
      for i := 1 to spW.Value do
         for j := 1 to spH.Value do
            if thing[i,j].Brush.Color = clBlack
               then temp := temp + '1,'
               else temp := temp + '0,';
      delete(temp,length(temp),1);
      memData.Lines.Add(temp);

end;

end.

